## Engine HeartBeat

Create an `Engine_heartbeat` queue bound to `canopsis.events` with routing key `#` in RabbitMQ.

```
cd cmd/engine-heartbeat

export CPS_MONGO_URL="mongodb://cpsmongo:canopsis@canopsis:27017/canopsis"
export CPS_AMQP_URL="amqp://cpsrabbit:canopsis@canopsis:5672/canopsis"
export CPS_REDIS_URL="redis://localhost:6379/0"
export CPS_DEFAULT_CFG=../../default_configuration.toml

go build . && ./engine-heartbeat
```

### Configuration

In the global configuration provided by `canopsis.Conf`:

```json
"heartbeat" : {
    "items" : [
        {
            "mappings" : [
                {"connector" : "myconnector"}
            ],
            "maxduration" : "10s"
        }
    ]
}
```
