# Initialisation.

## Introduction

La commande *init* permet d'initialiser les queues et les exchanges RabbitMQ à
l'aide d'une configuration.

Il est à terme de prévu d'initialiser les différents services dont canopsis à
besoin pour fonctionner.

## Utilisation
### Docker-compose

Pour utiliser *init* dans un environnement docker, il suffit juste de
lancer canopsis à l'aide de docker-compose et du fichier docker-compose.yml
à la racine du projet.

```sh
docker-compose up -d
```

### Canopsis classique

Si vous n'utilisez pas docker-compose pour démarrer canopsis, vous pouvez
lancer la commande manuellement.

```sh
CPS_AMQP_URL=amqp://cpsrabbit:canopsis@rabbitmq:5672/canopsis ./init
```

Ou si vous souhaitez utiliser une configuration particulière

```sh
CPS_AMQP_URL=amqp://cpsrabbit:canopsis@rabbitmq:5672/canopsis ./init -conf=./autre_initialisation.toml
```


## Compilation

  * Pour compiler le binaire :

```sh
make build
```

  * Pour créer l'image docker :

```sh
make docker_build
```

  Il est possible de spécifier un tag (par défaut: latest) en ajoutant
  TAG=MON_TAG à la fin de la précédente commande.
