ARG BASE

FROM ${BASE} AS build

ARG PROJECT_NAME
ARG BINARY_NAME

ENV PROJECT_DIR=${CPS_BASE_DIR}/cmd/${PROJECT_NAME}

RUN mkdir -p ${PROJECT_DIR}
WORKDIR $PROJECT_DIR

RUN make build -f ../../Makefile.cmd && cp ${BINARY_NAME} /${BINARY_NAME}

FROM alpine:latest

ARG BINARY_NAME
ARG PROJECT_NAME

RUN /usr/sbin/addgroup canopsis
RUN /usr/sbin/adduser -G canopsis -D -H -s /sbin/nologin canopsis

USER canopsis:canopsis

ENV CPS_BASE_DIR=/go/src/git.canopsis.net/canopsis/go-revolution/
ENV PROJECT_DIR=${CPS_BASE_DIR}/cmd/${PROJECT_NAME}
ENV CPS_DEFAULT_CFG=/default_configuration.toml
ENV _BINARY_NAME=${BINARY_NAME}

COPY --from=build /${BINARY_NAME} /
COPY --from=build ${CPS_BASE_DIR}/default_configuration.toml /

CMD ["/bin/sh", "-c", "/${_BINARY_NAME}"]
