#!/bin/bash
set -e
set -o pipefail

build_base="canopsis/go-build:${TAG}"
bin_base="canopsis/go-bin:${BINARY}-${TAG}"
bin_final="canopsis/${BINARY}:${TAG}"

echo "BUILD BASE IMAGE"

docker build \
    -f docker/Dockerfile.cmd.build \
    --build-arg GOLANG_IMAGE_TAG=${GOLANG_IMAGE_TAG} \
    -t ${build_base} \
    .

echo "BUILD BIN IMAGE"

docker build \
    -f docker/Dockerfile.cmd \
    --build-arg BASE=${build_base} \
    --build-arg BINARY_NAME=${BINARY} \
    --build-arg PROJECT_NAME=${BINARY} \
    -t ${bin_base} \
    .

if [ -f cmd/${BINARY}/Dockerfile ]; then
    echo "BUILD FINAL IMAGE"

    docker build \
        -f cmd/${BINARY}/Dockerfile \
        --build-arg BASE=${bin_base} \
        -t ${bin_final} \
        .
else
    echo "TAG FINAL IMAGE"

    docker tag ${bin_base} ${bin_final}
fi
