package context

import (
	"time"

	"git.canopsis.net/canopsis/go-revolution/lib/canopsis/types"
)

// Pending states:
//  OK: no modifications since last Extract
//  Insert: entity to be inserted
//  Update: entity to be updated to an existing one
const (
	PendingInsert = iota
	PendingUpdate
	PendingOK
)

// EntityState state is a Pending... state
type EntityState struct {
	Entity  types.Entity
	State   int
	Updated time.Time
}
