package json

import (
	"encoding/json"
	"fmt"

	"git.canopsis.net/canopsis/go-revolution/lib/canopsis/encoding"
)

type jsonEncoder struct {
}

type jsonDecoder struct {
}

func NewEncoder() encoding.Encoder {
	return &jsonEncoder{}
}

func (e *jsonEncoder) Encode(in interface{}) ([]byte, error) {
	b, err := json.Marshal(in)
	if err != nil {
		return []byte{}, encoding.NewEncodingError(fmt.Errorf("json encoder: %v", err))
	}
	return b, nil
}

func NewDecoder() encoding.Decoder {
	return &jsonDecoder{}
}

func (e *jsonDecoder) Decode(in []byte, out interface{}) error {
	if err := json.Unmarshal(in, out); err != nil {
		return encoding.NewDecodingError(fmt.Errorf("json decoder: %v", err))
	}
	return nil
}
