package entity

import (
	"git.canopsis.net/canopsis/go-revolution/lib/canopsis/cache"
	"git.canopsis.net/canopsis/go-revolution/lib/canopsis/types"
)

type service struct {
	cache   cache.Cache
	adapter Adapter
}

func (s *service) FlushBulk() error {
	return s.adapter.FlushBulk()
}

func (s *service) BulkInsert(entity types.Entity) error {
	return s.adapter.BulkInsert(entity)
}

func (s *service) BulkUpdate(entity types.Entity) error {
	return s.adapter.BulkUpdate(entity)
}

func (s *service) Get(id string) (types.Entity, bool) {
	centity, exists := s.cache.Get(id)
	if exists {
		return centity.(types.Entity), true
	}

	entity, exists := s.adapter.Get(id)
	return entity, exists
}

// NewService makes calls to cache and adapter to manipulate entities
func NewService(cache cache.Cache, adapter Adapter) Service {
	s := service{
		cache:   cache,
		adapter: adapter,
	}

	return &s
}
