package pbehavior

import (
	"git.canopsis.net/canopsis/go-revolution/lib/canopsis/types"
)

// PBehavior represents a comment in a PBehavior.
type PBehaviorComment struct {
	ID        string         `bson:"_id" json:"_id"`
	Author    string         `bson:"author" json:"author"`
	Timestamp *types.CpsTime `bson:"ts" json:"ts"`
	Message   string         `bson:"message" json:"message"`
}

type PBehaviorComments []*PBehaviorComment

// PBehavior represents a canopsis periodical behavior.
type PBehavior struct {
	ID            string            `bson:"_id,omitempty" json:"_id,omitempty"`
	Author        string            `bson:"author" json:"author"`
	Comments      PBehaviorComments `bson:"comments,omitempty" json:"comments,omitempty"`
	Connector     string            `bson:"connector" json:"connector"`
	ConnectorName string            `bson:"connector_name" json:"connector_name"`
	Eids          []string          `bson:"eids,omitempty" json:"eids,omitempty"`
	Enabled       bool              `bson:"enabled" json:"enabled"`
	Filter        string            `bson:"filter_" json:"filter_"`
	Name          string            `bson:"name" json:"name"`
	Reason        string            `bson:"reason" json:"reason"`
	Rrule         string            `bson:"rrule" json:"rrule"`
	Start         *types.CpsTime    `bson:"tstart" json:"tstart"`
	Stop          *types.CpsTime    `bson:"tstop" json:"tstop"`
	Type          string            `bson:"type_" json:"type_"`
}
