package stat

// Item contains the required informations for the Stats engine to work.
type Item struct {
	Connector     string
	ConnectorName string
	Component     string
	Resource      string
	EventOk       int
	EventKo       int
	ID            string
}

// NewItem creates a StatItem instance for you.
func NewItem(connector string, connectorName string, component string, resource string, entityID string, isOk bool) Item {
	var value int
	if value = 0; isOk {
		value = 1
	}

	return Item{
		Connector:     connector,
		ConnectorName: connectorName,
		Component:     component,
		Resource:      resource,
		EventOk:       value,
		EventKo:       1 - value,
		ID:            entityID,
	}
}
