package stat_test

import (
	"testing"

	"git.canopsis.net/canopsis/go-revolution/lib/canopsis/stat"
	. "github.com/smartystreets/goconvey/convey"
)

func TestStats(t *testing.T) {
	Convey("Give a ok event", t, func() {
		item := stat.NewItem("con", "conn", "comp", "r", "id", true)

		So(item.EventOk, ShouldEqual, 1)
		So(item.EventKo, ShouldEqual, 0)
	})

	Convey("Give a bad event", t, func() {
		item := stat.NewItem("con", "conn", "comp", "r", "id", false)

		So(item.EventOk, ShouldEqual, 0)
		So(item.EventKo, ShouldEqual, 1)
	})

	Convey("Give an event without resource", t, func() {
		item := stat.NewItem("con", "conn", "comp", "", "id", true)

		So(item.Resource, ShouldEqual, "")
		So(item.EventOk, ShouldEqual, 1)
	})
}
