package engine

import "github.com/streadway/amqp"

// PartialWorker implements basic engine functions
type PartialWorker interface {
	WorkerContinue() bool
	WorkerStopped()
	WorkerRecover()
}

// Worker ...
type Worker interface {
	PartialWorker
	WorkerConsumer() (<-chan amqp.Delivery, error)
	WorkerProcess(msg amqp.Delivery) error
}
