package utils

import (
	"fmt"
	"io/ioutil"
)

// ReadFile handles opening and reading file at given path
func ReadFile(path string) ([]byte, error) {
	source, err := ioutil.ReadFile(path)
	if err != nil {
		return []byte{}, fmt.Errorf("read file: %v", err)
	}
	return source, nil
}

// StringInSlice checks if a string is present in a list of strings
func StringInSlice(a string, list []string) bool {
	for _, b := range list {
		if a == b {
			return true
		}
	}
	return false
}
